/*
 * rrlogind - Time Warner RoadRunner logon client daemon -
 * Copyright (C) 1998, Joshua Jackson <jjackson@vortech.net>
 * Copyright (C) December, 1998 Sergei Viznyuk <sv@phystech.com>
 * 
 * This is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#ifndef ROADRUNNER_H
#define ROADRUNNER_H 

#define VERSION_ID       12
#define OS_ID            "Linux"
#define OS_ID_LEN        5
#define OS_VERSION       "2.1"
#define OS_VERSION_LEN   3

// Road Runner Message Request Types
#define RR_MSG_PROTONEG_REQ		1
#define RR_MSG_LOGIN_REQ		3
#define RR_MSG_AUTHLOGIN_REQ		4
#define RR_MSG_LOGOUT_REQ		6
#define RR_MSG_AUTHLOGOUT_REQ		7
#define RR_MSG_AUTH_REQ			10
#define RR_MSG_STATUS_REQ		11
#define RR_MSG_RESTART_REQ		13

// Road Runner Message Response Types
#define RR_MSG_PROTONEG_RESP		2
#define RR_MSG_LOGIN_RESP		5
#define RR_MSG_LOGOUT_RESP		8
#define RR_MSG_AUTH_RESP		9
#define RR_MSG_STATUS_RESP		12

// Road Runner Protocol Type Definitions
#define RR_PROTO_RESERVED		0
#define RR_PROTO_CHALLENGE		1

// Road Runner Message Parameter Definitions
#define RR_PARAM_RESERVED		0
#define RR_PARAM_PROTOLIST		1
#define RR_PARAM_PROTOSEL		2
#define RR_PARAM_CLIENTVER		3
#define RR_PARAM_OSID			4
#define RR_PARAM_OSVER			5
#define RR_PARAM_REASON			6
#define RR_PARAM_USERNAME		7
#define RR_PARAM_REQPORT		8
#define RR_PARAM_RESPTEXT		9
#define RR_PARAM_STATUSCODE		10
#define RR_PARAM_CREDS			11
#define RR_PARAM_NONCE			12
#define RR_PARAM_SEQNUM			13
#define RR_PARAM_HASH			14
#define RR_PARAM_LOGINPORT		15
#define RR_PARAM_LOGOUTPORT		16
#define RR_PARAM_STATUSPORT		17
#define RR_PARAM_SUSPEND		18
#define RR_PARAM_STATUSAUTH		19
#define RR_PARAM_RESTARTAUTH		20
#define RR_PARAM_BLINDING		21
#define RR_PARAM_TRUSTEDSERVERS		22
#define RR_PARAM_LOGINHASH		23
#define RR_PARAM_LOGINHOST		24

typedef struct rrOptions_s
  {
    ushort num;
    ushort len[25];
    void *val[25];
  } rrOptions_t;

#endif
