/*
 * rrlogind - Time Warner RoadRunner logon client daemon -
 * Copyright (C) December, 1998 Sergei Viznyuk <sv@phystech.com>
 * 
 * This is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include <stdio.h>
#include <stdlib.h>
#include <syslog.h>
#include <unistd.h>
#include <fcntl.h>
#include <signal.h>
#include "rrlogind.h"
#include "signals.h"

char		*ProgramName	=	NULL;
char            **ProgramEnviron=       NULL;
char		*RrPasswdFile	=	DEFAULT_RRPASSWDFILE;
void		*(*currState)()	=	&rrStart;
int		DebugFlag	=	0;
time_t		LeaseTime	=	DEFAULT_LEASETIME;
time_t          TimeOut         =	DEFAULT_TIMEOUT;
/*****************************************************************************/
int main(argn,argc,argv)
int argn;
char *argc[],*argv[];
{
  int killFlag		=	0;
  int s			=	1;
  int k			=	1;
  int i			=	1;

  while ( argc[i] )
    if ( argc[i][0]=='-' )
prgs: switch ( argc[i][s] )
	{
	  case 0:
	    i++;
	    s=1;
	    break;
	  case 'k':
	    s++;
	    killFlag=SIGTERM;
	    goto prgs;
          case 'r':
	    s++;
	    killFlag=SIGHUP;
	    goto prgs;
	  case 'd':
	    s++;
	    DebugFlag=1;
	    goto prgs;
	  case 't':
	    i++;
	    if ( argc[i] )
	      TimeOut=atol(argc[i++]);
	    else
	      goto usage;
	    s=1;
	    if ( TimeOut > 0 ) break;
	    goto usage;
	  case 'l':
	    i++;
	    if ( argc[i] )
	      LeaseTime=atol(argc[i++]);
	    else
	      goto usage;
	    s=1;
	    if ( LeaseTime > 0 ) break;
          default:
usage:	    fprintf(stderr,"\
RoadRunner Logon Client Daemon v."PROGRAM_VERSION"\n\
Copyright (C) 1998 Joshua Jackson <jjackson@vortech.net>\n\
Copyright (C) December, 1998 Sergei Viznyuk <sv@phystech.com>\n\
Usage: rrlogind [-dkr] [-l leasetime] [-t timeout] [rrpasswd_file]\n");
	    exit(1);
	}
    else
      argc[k++]=argc[i++];
  if ( k > 1 ) RrPasswdFile=argc[1];
  ProgramName=argc[0];
  ProgramEnviron=argv;
  if ( killFlag ) killPid(killFlag);
  checkIfAlreadyRunning();
  openlog(PROGRAM_NAME,LOG_PID,LOG_LOCAL0);
  signalSetup();
  alarm(TimeOut); TimeOut*=20;
  currState=(void *(*)())currState();
  alarm(0);
  if ( currState == NULL ) exit(1);
#ifndef DEBUG
  if ( fork() ) exit(0);
  setsid();
  if ( (i=open("/dev/null",O_RDWR,0)) >= 0 )
    {
      (void)dup2(i,STDIN_FILENO);
      (void)dup2(i,STDOUT_FILENO);
      (void)dup2(i,STDERR_FILENO);
      if ( i > 2 ) (void)close(i);
    }
#endif
  chdir("/");
  writePidFile();
  do currState=(void *(*)())currState(); while ( currState );
  unlink(PID_FILE_PATH);
  exit(1);
}
