/*
 * rrlogind - Time Warner RoadRunner logon client daemon -
 * Copyright (C) December, 1998 Sergei Viznyuk <sv@phystech.com>
 * 
 * This is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#ifndef RRLOGIND_H
#define RRLOGIND_H

#define PROGRAM_VERSION       "1.3"
#define PROGRAM_NAME          "rrlogind"
#define DEFAULT_TIMEOUT       60  // in secs
#define DEFAULT_LEASETIME     604800	// in secs = 7 days
#define DEFAULT_PORT          60000
#define DEFAULT_RRPASSWDFILE  "/etc/rrpasswd"
#define PID_FILE_PATH         "/var/run/rrlogind.pid"
#define LOSTSOCKMINPORT       7770
#define MAX_RR_MSG_SIZE       512
#define MAX_TRUSTED_SERVERS   8
#define MAX_CREDS_SIZE        256

void *rrStart();
void *rrInit();
void *rrLogon();
void *rrBound();
void *rrLogoff();
void *rrStop();

#endif
